global {
	loc = {}; --текущая локация
	mis_i = 1; --номер текущей миссии
	mis = {};
	
	blink = {0,0}, --текущее количество точек на радаре слева и справа
	enemies = {{},{}};
	locobjs = {{},{}};
	curr_event = {};
		
	units = {};
	graveyard = {};
	squads = {{},{},{}};
	reinforcement = {{},{},{}};
	last_turn = {nil,nil,nil};
	current_turn = {nil,nil,nil};
	
	ui_mode = 0;
	ui_type = 0; --тип интерфейса
	selected_y = 0;
	selected_dir = 1;
	selected_pos = {};
	selected_ny = 0;
	
	level_len = 6;
	
	log = '';--описание боя и результата последнего хода
	radar_log = '';--описание перемещения на радаре
	turn = 1; --номер хода
	
	--roster = { },
	hero = {}; --текущий персонаж
	

	foto_h = 1;
	foto_e = 1;
	foto_m = 1;
	foto_ready = false;
	
	--счетчики провалов, потерь, убитых противников
	battle_count = 0;
	losses_count = 0;
	frag_count = 0;
	hm_count = 0;
	gameres = 0;
	
	loc_add = ''; --локализация для одиночных миссий 
	locend_flag = false; --выставляется, чтобы правильно срабатывал запрет перехода по нажатию "ход"
	lang = 'ru';
}

MAX_SUP = 5

UI_VIEW = 0
UI_AIM = 1
UI_SUP = 2
UI_MOV = 3
UI_MOV_DIR = 4
UI_DEF = 5
UI_RECRUIT = 6

UIT_MENU = 0;
UIT_QUEST = 1;
UIT_LOC = 2;
UIT_HELP = 3;

UT_ATK = 1;
UT_SUP = 2;
UT_MOV = 3;
UT_PANIC = 4;

DIR_L = 1
DIR_R = 2

locale = {}

------------------------------------------------------------
---++++++++++++++++++**** дебаг функции
------------------------------------------------------------
function debug_swarms(txt)
	if txt==nil then txt='' end
	pn(txt..' swarms = '..enemy_count())
end

------------------------------------------------------------
---++++++++++++++++++**** темы
------------------------------------------------------------



------------------------------------------------------------
---++++++++++++++++++**** вспомогательные функции
------------------------------------------------------------
function parseargs(s)
  local arg = {}
  string.gsub(s, "(%w+)=([\"'])(.-)%2", function (w, _, a)
    arg[w] = a
  end)
  return arg
end
    
function collect(s)
  local stack = {}
  local top = {}
  table.insert(stack, top)
  local ni,c,label,xarg, empty
  local i, j = 1, 1
  while true do
    ni,j,c,label,xarg, empty = string.find(s, "<(%/?)([%w:]+)(.-)(%/?)>", i)
    if not ni then break end
    local text = string.sub(s, i, ni-1)
    if not string.find(text, "^%s*$") then
      table.insert(top, text)
    end
    if empty == "/" then  -- empty element tag
      table.insert(top, {label=label, xarg=parseargs(xarg), empty=1})
    elseif c == "" then   -- start tag
      top = {label=label, xarg=parseargs(xarg)}
      table.insert(stack, top)   -- new level
    else  -- end tag
      local toclose = table.remove(stack)  -- remove top
      top = stack[#stack]
      if #stack < 1 then
        error("nothing to close with "..label)
      end
      if toclose.label ~= label then
        error("trying to close "..toclose.label.." with "..label)
      end
      table.insert(top, toclose)
    end
    i = j+1
  end
  local text = string.sub(s, i)
  if not string.find(text, "^%s*$") then
    table.insert(stack[#stack], text)
  end
  if #stack > 1 then
    error("unclosed "..stack[#stack].label)
  end
  return stack[1]
end

function read_xml(name)
  local file = assert(io.open(instead_gamepath() .. "/" .. name, "r"));
  local src = file:read("*all");  
  file:close();
  return collect(src);
end

function extract_locale_str(tbl,vlang)
	assert(type(tbl)=='table','Wrong locale.xml - empty tag')
	assert(tbl.label == 'line','Wrong locale.xml - tag '..tbl.label..' is not <line>')	
	
	local k,v,r
	r=''
	
	for k,v in pairs(tbl) do
		if tbl[k].label == vlang then 
			return 	tbl[k][1]
		end
	end		
	
	return nil
end


function set_locale(vlang,filename)
	local r = ''
	
	if filename == nil then 
		filename = 'locale.xml' 
	else 
		loc_add = filename 
--		r = loc_add
	end
	
	
	
	local locxml = read_xml(filename)
	local k,v,kk,vv,tag,val
	
	
	assert(locxml[1].label == 'lines','Wrong locale.xml - root tag must be <lines>')
	
	for k,v in pairs(locxml[1]) do
		if k~='xarg' and k~='label' then 
			tag = locxml[1][k].xarg.id
			val = extract_locale_str(locxml[1][k],vlang)
			if val == nil then val = '##'..tag..'##' end
			locale[tag] = val
			--r=r..tag..' = '..locale[tag]..'^'
		end
	end		

	return r
	
end

function _l(key)
	assert(key~=nil and key~='')
	if locale[key] ~= nil then return locale[key] else return '??'..key..'??' end
end

function _r(str)
	assert(str~=nil)
	return function(s) return str end
end


function _rl(key)
	return function(s) return _l(key) end
end




function reset_game()
	
	mis[mis_i]._step = 0
	mis_i = 1
	foto_ready = false
	battle_count = 0
	losses_count = 0
	frag_count = 0
	hm_count = 0
	locend_flag = false;
end

function stop_all_noise()
		stop_music()
		local i
		for i=0,10 do stop_sound(i) end
end

function log_add(txt,alert_level)
	assert(txt~=nil)
	log = txt
	
	if alert_level==1 then
		add_sound('snd/beep.ogg',2,1)
	elseif alert_level==2 then
		add_sound('snd/alarm1.ogg',2,3)
	elseif alert_level==3 then
		add_sound('snd/alarm1.ogg',2,5)
	end
	
end

function size(s)
	if s == nil then
		return 0
	end
	return stead.table.maxn(s)
end

function rnd2(min,max)
	return rnd(max-min+1) + min-1
end

function inv_clear()
	me().obj.zap(me().obj);
end	

function foto_rnd()
	foto_h = rnd(4)
	foto_e = rnd(4)
	foto_m = rnd(4)
	return true
end

function foto_get()
	return 'img/'..prefs.thm..'/'..'foto/h'..foto_h..'.png;'..'img/'..prefs.thm..'/'..'foto/e'..foto_e..'.png;'..'img/'..prefs.thm..'/'..'foto/m'..foto_m..'.png;'
end

-- хранимый объект с динамическим текстом сохраняемым в сейвах

my_stat = stat {
	nam = 'Стат',
	_text = '',
	disp = function (s) return s._text end
}

function take_my_stat(txt)
	assert(txt ~= nil)
	my_stat._text = txt
	take(my_stat)
	
end

function flang(dir)
	if dir==1 then return _l('gui.left') else return _l('gui.right') end
end

--приведение процентов к диапазону 1-99
function norm_chance(chance)
	local r
	
	if chance>90 then
		r = 90+math.ceil ( (chance-90)/10)
	elseif chance<10	then
		r = 10 + math.ceil ( chance/10 )
	else
		r = chance
	end
	
	if r<=5 then r=5 
	elseif r>=100 
	then r=99 end
	
	return r
	
end

--дистанции передвижения и стрельбы
function norm_dist(dist)
	if dist<0 then return 0 else return dist end
end


--смена интерфейса (внутри одной темы)
function set_ui(newui)
	assert(newui == UIT_MENU or newui ==  UIT_QUEST or newui == UIT_LOC or newui == UIT_HELP)
	ui_type = newui
	
	if ui_type==UIT_MENU then 
		theme.gfx.bg('theme/'..prefs.thm..'/bgr.jpg') 
	else 
		assert(thm[prefs.thm].bgr[ui_type] ~= nil)
		theme.gfx.bg('theme/'..prefs.thm..'/'..thm[prefs.thm].bgr[ui_type] )
	end
	
	
end

------------------------------------------------------------
---++++++++++++++++++**** абстрактный класс для всех что на карте
------------------------------------------------------------
--снять выделение со всех
function mapobj_deselect_all()
	local i
	for i =1,level_len do
		if units[i] ~= nil then units[i]._selected = false end
		if enemies[1][i] ~= nil then enemies[1][i]._selected = false end
		if enemies[2][i] ~= nil then enemies[2][i]._selected = false end
		if locobjs[1][i] ~= nil then locobjs[1][i]._selected = false end		
		if locobjs[2][i] ~= nil then locobjs[2][i]._selected = false end			
	end

	
end

function mapobj_click(s)
				mapobj_deselect_all();
				s._selected = true;
				inv_clear();							
				take(s) 
				if s.snd_sel ~=nil then add_sound(s.snd_sel) end
				return true
end

mapobj = function (s)
	if s.click==nil then 
		s.click = mapobj_click
	end	
	
	s._selected = false;
	
	s.isMapobj = true					
		
		
	return stat(s)
end

------------------------------------------------------------
---++++++++++++++++++**** объект в локации (класс locobj)
------------------------------------------------------------
--подсчет количества 
function locobj_count(dir)
	local l,r,i = 0,0
	
	for i=1,level_len do
		if locobjs[1][i]~=nil then l=l+1 end
		if locobjs[2][i]~=nil then r=r+1 end	
	end
	
	if dir == nil then
		return l+r
	elseif dir == 1 then
		return l
	else
		return r
	end

end

--помещает объект в текущую локацию	
function place_obj(s,dir,pos)
	assert(s ~= nil)
	assert(s.isLocobj)
	assert(dir == 1 or dir == 2)
	assert(pos>0 and pos<= level_len)
	locobjs[dir][pos] = s
	s._dir = dir
	s._pos = pos
	if s.usable then
		s._used = false
		s._active = false
	end
			
end	

m_use = menu {
	nam = 'Использовать',
	disp = function(s) return _l('gui.use') end,
	_parent = nil, --тут должна быть локация
		
	menu = function(s)	
		assert(s._parent ~= nil)
		
		
		if s._parent.usable and s._parent._used == false
		then
			s._parent._used = true
			s._parent.use(s._parent)
			location_refresh()		
			
		end
		
	end
}

locobj = function (s)
	s.selected = false
	s.sp = 0
	
	s.isLocobj = true
	
	if s.usable == nil then s.usable = false end
	if s.multiuse == nil then s.multiuse = true end
	
	s._used = false;
	s._activ = false;
	
	s.disp	= function (s)
			local t,tt
			if s.text~=nil and s.text()~=nil then tt = s.text() else tt='' end
			t=''
			t = t..imgr('img/'..prefs.thm..'/'..'l_'..s.code..'.png')..txtb(s.nam())..'^'.._l('gui.threat')..': '..s.danger..'^^^^^'..tt..'^'
			
			return t
		end
	
	
	s.img_code = function(s,y)
			
		local im = ''
		--выделение
		if s._selected then 
			im = im..'img/'..prefs.thm..'/'..'light_y.png;'
		end			
		--иконка
		im = im..'img/'..prefs.thm..'/'..'l_'..s.code..'.png;'	
		
		-- опасность
		if s.danger>0 then 	im = im..'img/'..prefs.thm..'/'..'danger'..s.danger..'.png;'end	
		
		
		--значок действия
		if s.usable then		
								
			if s._used then
				im = im..'img/'..prefs.thm..'/'..'l_used.png;'	
			elseif s._activ then
				im = im..'img/'..prefs.thm..'/'..'l_activ.png;'
			else
				im = im..'img/'..prefs.thm..'/'..'l_passiv.png;'	
			end
		
		end

		return im
		end
	
	s.click = function(s)
		assert(s ~= nil)
		
		mapobj_click(s)
		
		if s.usable and s._used == false and s._activ then
			take(m_use)
			m_use._parent = s		
		end	
		
		return true
	end
		return mapobj(s)
		
end;

------------------------------------------------------------
---++++++++++++++++++**** событие (класс event)
------------------------------------------------------------

-- продвижение противника из радара на позицию прямой видимости 
function enemy_advance(count, dir, pos,et, noblink)
	count = tonumber(count)
	pos = tonumber(pos)
	dir = tonumber(dir)
	assert( count>0 )
	assert(pos>0 and pos<= level_len)
	assert(dir == 1 or dir == 2)
	local t	
	
	if noblink then blink[dir]=blink[dir]+count end
	
	if et == nil then et = loc.enemy_typ[ rnd( size(loc.enemy_typ) )  ]	end
	
	if blink[dir]==0 then return false end
	
	if count > blink[dir] then count = blink[dir] end
	--удаляем с радара
	blink[dir] = blink[dir] - count
	
	if enemies[dir][pos] == nil then
		new_swarm(dir,pos,count,et)
		enemies[dir][pos]._mov_from[1] = true;	
		radar_log = radar_log..''..img('img/'..prefs.thm..'/'..'ico_enemy.png')..count..' '..img('img/'..prefs.thm..'/'..'ico_blink.png')..' '..img('img/'..prefs.thm..'/'..'utrv_mov.png')..flang(dir)..pos..'^'		
	else
		enemies[dir][pos]._size = enemies[dir][pos]._size + count
		enemies[dir][pos]._mov_from[1] = true;	
		radar_log = radar_log..''..img('img/'..prefs.thm..'/'..'ico_enemy.png')..count..' '..img('img/'..prefs.thm..'/'..'ico_blink.png')..' '..img('img/'..prefs.thm..'/'..'utrv_mov.png')..flang(dir)..pos..img('img/'..prefs.thm..'/'..'utrv_union.png')..'^'
	end
	

	
	
end

-- продвижение суммарно от min до max 
function enemy_random_advance( min, max)


	if min<0 then min =0 end
	if max<0 then max =0 end

	assert(min <= max)
	
   	local la,i,j,k,t,m,l
	t = ''
	la = {}

	--objcount = rnd2(loc.ea_locobj[1],loc.ea_locobj[2])
	gcount = rnd2(min,max)
	
	-- в la кладем пропорционально уровню опасности
	for i=1,level_len do for j = 1,2 do
		if locobjs[j][i] ~= nil then 	
			for k=1,locobjs[j][i].danger do
				--если на радаре по флангу непусто то по 1 шансу на каждый уровень активации и +много для 5-го уровня
				if blink[j]>0 then 
					table.insert(la, {j,i} )			
					if k==5 then 
						for l=1,10 do
							table.insert(la, {j,i} )	
						end				
					end --k=5
				end -- blink
			end --for k
		end	
	end end	
	
	if size(la) == 0 then return false end
		
	-- продвижение 
	for i=1,gcount do
		k = rnd(size(la))
		enemy_advance( 1 , la[k][1], la[k][2])	
	end	
   
end

event = function (s)
	
	--if s.run == nil then s.run = event_run_era end
	
	s.disp = function(s)
			if s.text~=nil then 
				return s.text() 
			else 
				return ''
			end
		end
	
	return stat(s)
end

------------------------------------------------------------
----------------***  типовые события
------------------------------------------------------------

ev_spawn = event{
	nam = 'Противник приближается',
	run = function(s)
		enemy_random_advance( loc.ea_count[prefs.diff][1], loc.ea_count[prefs.diff][2]) 	
		return true
	end

}

------------------------------------------------------------
---++++++++++++++++++**** локация (класс location)
------------------------------------------------------------
----------------*** главное меню, помощь, радар
------------------------------------------------------------
--радар и информация по уровню
radar = stat { 
	nam = 'Радар';
	disp = function(s)
		local t=''
		
		t=t..img('img/'..prefs.thm..'/'..'ico_radar.png')..txtb(_l('gui.radar'))..'^'
		t=t.._l('gui.currturn')..':'..turn..' '.._l('gui.currsize')..':'..unit_count()..'^^'  
		
		
		if blink[2]>20 then
			t=t..imgr('img/'..prefs.thm..'/'..'blink_r_M.png') 
		elseif blink[2]>9 then
			t=t..imgr('img/'..prefs.thm..'/'..'blink_r_A.png') 
		else
			t=t..imgr('img/'..prefs.thm..'/'..'blink_r_'..blink[2]..'.png') 
		end		
		if blink[1]>20 then
			t=t..imgr('img/'..prefs.thm..'/'..'blink_l_M.png') 
		elseif blink[1]>9 then
			t=t..imgr('img/'..prefs.thm..'/'..'blink_l_A.png') 
		else
			t=t..imgr('img/'..prefs.thm..'/'..'blink_l_'..blink[1]..'.png') 
		end

		t=t..img('img/'..prefs.thm..'/'..'ico_blink.png')..''..blink[1]+blink[2]..' ['..blink[1]..'-'..blink[2]..']'..'^'..img('img/'..prefs.thm..'/'..'ico_enemy.png')..enemy_count(1)+enemy_count(2)..'^^^'
		
		t=t..radar_log
		
		if curr_event ~=nil and curr_event.text ~= nil then 	
			t=t..curr_event.text()
		end	

		
		
		
		return t
	end
};

xback = xact('back',code [[back()]])

hlp_stat1 = stat {nam = 'Опер', disp = function(s) return img('img/'..prefs.thm..'/'..'ico_note.png').._l('gui.operinfo') end }
hlp_stat2 = stat {nam = 'Опер', disp = function(s) return img('img/'..prefs.thm..'/'..'ico_help.png').._l('gui.helpinfo') end }

hlp_back = menu {nam='Назад',disp=function(s) return _l('gui.back') end, menu=function(s) set_ui(UIT_LOC); walk(loc) end}

hlp_mis = menu {nam='План операции',disp=function(s) return _l('gui.missionplan') end,menu=function(s) objs().zap(objs()); place(hlpo_mis,m_help); return true end}
hlpo_mis = obj {nam='План операции', dsc= function(s)  
										if mis[mis_i].text ~= nil and mis[mis_i].text() ~= nil then return txtb(_l('gui.missionplan'))..' '.. mis[mis_i].nam()..'^^'..mis[mis_i].text() 
										else return txtb(mis[mis_i].nam())..'^^'.._l('gui.nodata')
										end
									end 
				}

hlp_loc = menu {nam='Сектор',disp=function(s) return _l('gui.area') end,menu=function(s) objs().zap(objs());  place(hlpo_loc,m_help); return true end}
hlpo_loc = obj {nam='Сектор', dsc= function(s)  
										if loc.text ~= nil and loc.text() ~= nil then return txtb(loc.nam())..'^^'..loc.text() 
										else return txtb(loc.nam())..'^^'.._l('gui.nodata')
										end
									end 
				}

				
hlp_map = menu {nam='Карта местности',disp=function(s) return _l('gui.map') end,menu=function(s) objs().zap(objs());  place(hlpo_map,m_help); return true end}
hlpo_map = obj {nam='Карта местности', dsc= function(s)  
										if loc.map() ~= nil then return txtb(_l('gui.map'))..'^^'.._l('gui.currarea')..': '..loc.nam()..'^'..loc.map() 
										else return txtb(_l('gui.map'))..'^^'.._l('gui.currarea')..': '..loc.nam()..'^'.._l('gui.nomapdata')
										end
									end 
				}
				
hlp_squads = menu {nam='Отряд',disp=function(s) return _l('gui.squad') end,menu=function(s) objs().zap(objs()); place(hlpo_squads,m_help); return true end}
hlpo_squads = obj {nam='Отряд', dsc= function(s)  
										return txtb(_l('gui.squad'))..'^^'..units_stat()										
									end 
				}				


				

hlp_2 = menu {nam='ЕСВКС',disp=function(s) return _l('gui.esvks') end,menu=function(s) objs().zap(objs()); place(hlpo_2,m_help); return true end}
hlpo_2 = obj {nam='ЕСВКС', dsc=function(s) return txtb(_l('gui.esvks2')..'^^').._l('info.esvks')..'^' end }






hlp_3 = menu {nam='Характеристики бойцов',disp=function(s) return _l('gui.stathelp') end,menu=function(s) objs().zap(objs()); place(hlpo_3,m_help); return true end}
hlpo_3 = obj {nam='Характеристики бойцов', dsc=function(s) return txtb(_l('gui.stathelp'))..'^^'.._l('info.stathelp') end }

hlp_4 = menu {nam='Условные обозначения',disp=function(s) return _l('gui.pics') end,menu=function(s) objs().zap(objs()); place(hlpo_4,m_help); return true end}
hlpo_4 = obj {nam='Условные обозначения', dsc=function(s) return  txtb(_l('gui.pics'))..'^^'..img('img/'..prefs.thm..'/'..'utrv_mov.png')..' '.._l('info.esvks2')..'^'..img('img/'..prefs.thm..'/'..'utrv_chg.png')..' '.._l('info.esvks3')..'^'..img('img/'..prefs.thm..'/'..'utrv_sup.png')..' '.._l('info.esvks4')..'^'..img('img/'..prefs.thm..'/'..'utrv_atk.png')..' '.._l('info.esvks5')..'^'..img('img/'..prefs.thm..'/'..'utrv_deff.png')..' '.._l('info.esvks6')..'^'..img('img/'..prefs.thm..'/'..'utrv_defr.png')..' '.._l('info.esvks7')..'^'..img('img/'..prefs.thm..'/'..'utrv_union.png')..' '.._l('info.esvks8')..'^^'..img('img/'..prefs.thm..'/'..'ico_alert.png')..' '.._l('gui.pichlp1')..'^'..img('img/'..prefs.thm..'/'..'ico_info.png')..' '.._l('gui.pichlp2')..'^'..img('img/'..prefs.thm..'/'..'ico_use.png')..' '.._l('gui.pichlp3')..'^^'..img('img/'..prefs.thm..'/'..'ico_blink.png')..' '.._l('gui.pichlp8')..'^'..img('img/'..prefs.thm..'/'..'ico_enemy.png')..' '.._l('gui.pichlp9')..'^'..img('img/'..prefs.thm..'/'..'ico_hit.png')..' '.._l('gui.pichlp10')..'^'..img('img/'..prefs.thm..'/'..'ico_miss.png')..' '.._l('gui.pichlp11')..'^^'..img('img/'..prefs.thm..'/'..'ico_def.png')..' '.._l('gui.pichlp12')..'^'..img('img/'..prefs.thm..'/'..'ico_def_ok.png')..' '.._l('gui.pichlp13')..'^'..img('img/'..prefs.thm..'/'..'ico_med.png')..' '.._l('gui.pichlp14')..'^'..img('img/'..prefs.thm..'/'..'ico_killed.png')..' '.._l('gui.pichlp15')..'^^' end}




hlp_bf = menu {nam='Поле боя',disp=function(s) return _l('gui.bfhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_bf,m_help); return true end}
hlpo_bf = obj {nam='Поле боя', dsc=function(s) return txtb(_l('gui.bfhelp'))..'^^'.._l('info.bfhelp')..'^'..'3'..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac3.png;')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_door.png;img/'..prefs.thm..'/danger1.png;')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l.png;img/'..prefs.thm..'/'..'z_11.png;')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac2.png;')..'^^'.._l('info.bfhelp2') end }

hlp_def = menu {nam='Защита',disp=function(s) return _l('gui.defhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_def,m_help); return true end}
hlpo_def = obj {nam='Защита', dsc=function(s) return txtb(_l('gui.defhelp'))..'^^'.._l('info.defhelp')..'^'..'3'..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac3.png;')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/support_2.png')..'^^'.._l('info.defhelp2')..'^'..'3'..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac3.png;')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_r.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/support_2.png') end }

hlp_mov = menu {nam='Движение',disp=function(s) return _l('gui.movhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_mov,m_help); return true end}
hlpo_mov = obj {nam='Движение', dsc=function(s) return txtb(_l('gui.movhelp'))..'^^'.._l('info.movhelp')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/o.png;img/'..prefs.thm..'/x.png')..'^'.._l('info.movhelp2')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/dir_1.png')..img('pad:4 6 0 0,img/'..prefs.thm..'/o.png')..img('pad:4 6 0 0,img/'..prefs.thm..'/dir_2.png')..'^'.._l('info.movhelp3') 
end }

hlp_atk = menu {nam='Атака',disp=function(s) return _l('gui.atkhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_atk,m_help); return true end}
hlpo_atk = obj {nam='Атака', dsc=function(s) return txtb(_l('gui.atkhelp'))..'^^'.._l('info.atkhelp')..'^'..'3'..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac4.png;img/'..prefs.thm..'/aim.png;')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l.png;img/'..prefs.thm..'/'..'z_11.png;')..'^'.._l('info.atkhelp2')..'^'..img('img/'..prefs.thm..'/'..'ico_enemy.png')..img('img/'..prefs.thm..'/'..'ico_enemy.png')..img('img/'..prefs.thm..'/'..'ico_enemy.png')..img('img/'..prefs.thm..'/'..'ico_enemy.png')..'^'..img('img/'..prefs.thm..'/'..'ico_miss.png')..img('img/'..prefs.thm..'/'..'ico_hit.png')..img('img/'..prefs.thm..'/'..'ico_hit.png')..'^^'.._l('info.atkhelp3') 
end }

hlp_sup = menu {nam='Поддержка',disp=function(s) return _l('gui.suphelp') end,menu=function(s) objs().zap(objs()); place(hlpo_sup,m_help); return true end}
hlpo_sup = obj {nam='Поддержка', dsc=function(s) return txtb(_l('gui.suphelp'))..'^^'.._l('info.suphelp')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/sup.png;img/'..prefs.thm..'/support_4.png')..'^^'.._l('info.suphelp2')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/support_5.png')..'^^'.._l('info.suphelp3') end }


hlp_turn = menu {nam='Защита',disp=function(s) return _l('gui.turnhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_turn,m_help); return true end}
hlpo_turn = obj {nam='Защита', dsc=function(s) return txtb(_l('gui.turnhelp'))..'^^'.._l('info.turnhelp')..'^^'.._l('info.turnhelp2')..'^'..'3'..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac3.png;')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/support_2.png;img/'..prefs.thm..'/def.png')..'^^'.._l('info.turnhelp3') end }


hlp_ord = menu {nam='Отдача приказов',disp=function(s) return _l('gui.ordhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_ord,m_help); return true end}
hlpo_ord = obj {nam='Отдача приказов', dsc=function(s) return txtb(_l('gui.ordhelp'))..'^^'.._l('info.ordhelp')..'^'..img('img/'..prefs.thm..'/'..'ico_atk.png')..' '.._l('info.ordhelp2')..'^'..img('img/'..prefs.thm..'/'..'ico_mov.png')..' '.._l('info.ordhelp3')..'^'..img('img/'..prefs.thm..'/'..'ico_sup.png')..' '.._l('info.ordhelp4')..'^^'.._l('info.ordhelp5')..'^'..'3'..img('pad:4 6 0 0,img/'..prefs.thm..'/alien_0.png;img/'..prefs.thm..'/ac3.png;')..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l_n.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/support_2.png;img/'..prefs.thm..'/act_mov.png')..'^^'.._l('info.ordhelp6')..' '..img('img/'..prefs.thm..'/'..'ico_none.png') end }

hlp_com = menu {nam='Отдача приказов',disp=function(s) return _l('gui.comhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_com,m_help); return true end}
hlpo_com = obj {nam='Отдача приказов', dsc=function(s) return txtb(_l('gui.comhelp'))..'^^'.._l('info.comhelp')..'^^'.._l('info.comhelp2') end }

hlp_obj = menu {nam='Поле боя',disp=function(s) return _l('gui.objhelp') end,menu=function(s) objs().zap(objs()); place(hlpo_obj,m_help); return true end}
hlpo_obj = obj {nam='Поле боя', dsc=function(s) return txtb(_l('gui.objhelp'))..'^^'.._l('info.objhelp2')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_panel.png;img/'..prefs.thm..'/danger1.png;img/'..prefs.thm..'/l_passiv.png;')..img('pad:4 6 0 0,img/'..prefs.thm..'/o.png;')..'^'.._l('info.objhelp3')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_panel.png;img/'..prefs.thm..'/danger1.png;img/'..prefs.thm..'/l_activ.png;')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l_n.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/act_mov.png;')..'^'.._l('info.objhelp4')..'^3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_panel.png;img/'..prefs.thm..'/danger1.png;img/'..prefs.thm..'/l_used.png;')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_l_n.png;img/'..prefs.thm..'/'..'z_11.png;img/'..prefs.thm..'/act_mov.png;') end }

hlp_obj0 = menu {nam='Поле боя',disp=function(s) return _l('gui.obj0help') end,menu=function(s) objs().zap(objs()); place(hlpo_obj0,m_help); return true end}
hlpo_obj0 = obj {nam='Поле боя', dsc=function(s) return txtb(_l('gui.obj0help'))..'^^'.._l('info.obj0help2')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_hill.png;img/'..prefs.thm..'/danger2.png')..img('pad:4 6 0 0,img/'..prefs.thm..'/u_gunner_r.png;img/'..prefs.thm..'/'..'z_11.png;')..'^^'.._l('info.obj0help3')..'^'..'3'..img('pad:4 6 0 0,blank:80x80')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_panel.png;img/'..prefs.thm..'/danger1.png;')..img('pad:4 6 0 0,img/'..prefs.thm..'/o.png')..img('pad:4 6 0 0,img/'..prefs.thm..'/l_hill.png;img/'..prefs.thm..'/danger4.png') end }




hlp_set = menu {nam='настройки',disp=function(s) return  _l('gui.set') end, menu=function(s) walk(msettings) return true end}

m_help = room {
	nam = 'Справочная система',
	disp= function(s) return img('img/'..prefs.thm..'/'..'ico_note.png').._l('gui.data') end,
	enter = function(s)
		if ui_mode ~= UI_VIEW then return false  end 
	end,
	
	entered = function(s)
		inv_clear();	
		take(hlp_back) 
		take(hlp_set ) 
		take(hlp_stat1)
		
		take(hlp_map)
		take(hlp_mis)
		--take(hlp_loc)
		take(hlp_squads)
		

		take(hlp_stat2)	
		
		take(hlp_bf)
		take(hlp_turn)
		take(hlp_ord)
		take(hlp_com)
		take(hlp_atk)
		take(hlp_mov)
		take(hlp_sup)
		take(hlp_def)
		take(hlp_3) --хар-ки бойцов
		take(hlp_obj0)
		take(hlp_obj)
		take(hlp_2) --есвкс
		take(hlp_4) --условные

		
		set_ui(UIT_HELP)
		hlp_map.menu(hlp_map)
		
		return true
	end,
	left = function(s)
		inv_clear();
		take(radar);
	end,

}

m_radar = room{ nam = 'Радар',
			disp= function(s) return img('img/'..prefs.thm..'/'..'ico_radar.png').._l('gui.radar') end,
				enter = function(s)
					if ui_mode ~= UI_VIEW then return false end 
					inv_clear();
					if not m_radar._disabled then take( radar ) end
					return false;
				end
				}

battle_stat = stat {
	nam = 'Последние результаты';
	disp = function(s)
		return img('img/'..prefs.thm..'/'..'ico_message.png')..txtb(_l('gui.message')..'^')..log
	end

}

m_battle_stat = room{ nam = 'Сообщение',
				disp= function(s) return img('img/'..prefs.thm..'/'..'ico_message.png').._l('gui.message') end,
				enter = function(s)
					if ui_mode ~= UI_VIEW  then return false end 
					inv_clear();
					take( battle_stat )
					return false;
				end
				}

m_endturn = room{ nam = 'Ход',
				disp= function(s) return img('img/'..prefs.thm..'/'..'ico_turn.png').._l('gui.turn') end,
				enter = function(s)
					if ui_mode ~= UI_VIEW then return false end 
					inv_clear();

					
					locend_flag = false
					aim_all(false)
					mapobj_deselect_all()
					defence();
					return locend_flag; --из defence есть вызов endturn и walk изнутри него сработает только если locend_flag == true
				end
				}	
				
m_endturn2 = room{ nam = 'Далее',
				disp= function(s) return img('img/'..prefs.thm..'/'..'ico_turn.png').._l('gui.next') end,
				enter = function(s)					
					disable(m_endturn2)
					aim_all(false)
					mapobj_deselect_all()
					locend_flag = false
					endturn()
					return locend_flag; --есть вызов endturn walk изнутри него сработает только если locend_flag == true
				end
				}	
				
------------------------------------------------------------
----------------*** обсчет защиты, конца хода и модификаторов
------------------------------------------------------------				
				
--- фаза защиты
function defence()
	local i,j,needdef
		--переход в режим защиты в начале следующего хода
	needdef = false
	for i=1,level_len do
		if units[i] ~= nil and (enemies[1][i]~=nil or enemies[2][i]~=nil) 
		then
			needdef = true
			selected_pos[i]=true
		else
		 	selected_pos[i]=false
		end	
	end
	
	if needdef then 
		ui_mode = UI_DEF 
		take_my_stat(_l('gui.defencehint'));
				
		disable(m_endturn)
		disable(m_radar)
		disable(m_help)
		disable(m_battle_stat)
	else
		endturn()
	end
	
	
	
end

--- пересчет модификаторов выполняется при перемещении или смерти бойца, смерти противника, конце хода
function refresh_mods()
	local i,j
	for i=1,level_len do	
		--бойцы
		if units[i] ~= nil then
			--сброс модификаторов
			units[i]._mov = 0
			units[i]._range = 0
			units[i]._acc = 0
			units[i]._def = 0			
		end
	end
	
		--модификатор от события
	if curr_event ~=nil and curr_event.act_turn ~= nil then 	
		curr_event.act_turn()
	end
	
		--применение спецсвойств противника
	for i=1,level_len do	
		for j =1,2 do
		if enemies[j][i] ~= nil and enemies[j][i].act_turn ~= nil then
				enemies[j][i].act_turn(enemies[j][i])
		end
		end --for j
	end--for i	

	--применение спецсвойств объектов
	for i=1,level_len do	
		for j =1,2 do
		if locobjs[j][i] ~= nil and locobjs[j][i].act_turn ~= nil then
				locobjs[j][i].act_turn(locobjs[j][i],j,i)
		end
		end --for j
	end--for i		
	
	--применение спецсвойств бойцов
	for i=1,level_len do	
		--бойцы
		if units[i] ~= nil and units[i].act_turn then
			units[i].act_turn(units[i])		
		end
	end
	
	
	
	
	
end

				
----- обсчет следующего хода
function endturn()
	assert(loc ~= nil and loc.isLoc)
	enable(m_endturn)
	enable(m_radar)
	enable(m_help)
	enable(m_battle_stat)	
	
	
	local i,j,needdef

	ui_mode = UI_VIEW

	
	log_add('') --стираем последнее
	inv_clear()
	
	if not m_radar._disabled then take( radar ) end

	--высадка по флагу
	if turn == 0 and loc.disembark then
		swarm_kill_all()	
		squads_disembark()	
	end
	turn = turn + 1
	
	
	--проверка условий поражения  
	if loc.fail_cond(loc) then
		battle_count = battle_count + 1
		inv_clear()
		stop_all_noise() 
		set_music('track/fail__Efiel_-_afternoon_nap.ogg')
		if mis[mis_i].isMission then walk(fail_screen) else walk(fail_screen_ep2) end
		locend_flag = true
		return true
	end

	--проверка условий победы
	if loc.win_cond(loc) then
		locend_flag = true
		mission_advance()
		return true
	end

	--очистка и начальные установки
	radar_log = ''
	for i=1,level_len do	
		--бойцы
		if units[i] ~= nil then
			units[i]._ready = true;	
			--сброс модификаторов
			units[i]._mov = 0
			units[i]._range = 0
			units[i]._acc = 0
			units[i]._def = 0			
		end
		
		
		for j =1,2 do
		
		if locobjs[j][i] ~= nil then
			locobjs[j][i]._activ = false;
			if locobjs[j][i].multiuse then 
					locobjs[j][i]._used = false;
			end
			
			
		end
		
		if enemies[j][i] ~= nil then
			enemies[j][i]._ready = true
			enemies[j][i]._mov_from = {false,false,false,false,false}
		end
		
		
		end --for j
		
		
	end--for i
	for i=1,3 do
		last_turn[i] = current_turn[i]
		current_turn[i] = nil
	end

	--перемещение противника

	for i=1,level_len do	
		for j =1,2 do
		if enemies[j][i] ~= nil and enemies[j][i].act_mov ~= nil then
				enemies[j][i].act_mov(enemies[j][i])
		end
		end --for j
	end--for i	
	
	--выбор таймерноего или случайного события (приближение противника)
	curr_event = nil
	if loc.timer_events[turn] ~= nil 
	then
		curr_event = loc.timer_events[turn]
	else --нет таймерного события, выбираем случайное
		if size(loc.random_events)>0 then
			curr_event = loc.random_events[rnd(size(loc.random_events))]
		end
	end
	
	if curr_event ~= nil then curr_event.run(curr_event) end
	

	-- пересчет модификаторов
	refresh_mods()

	return true
	
end

		
location_refresh = function()
	inv_clear();

	refresh_mods()
	
	ui_mode = UI_VIEW
	aim_all(false)
	mapobj_deselect_all()
	walk(loc)
	walk(m_battle_stat)
	
end

------------------------------------------------------------
----------------*** типовые кондишены для побед и поражений
------------------------------------------------------------	

-- проигрыш если всех убили
function fail_cond_std(s)
	assert(s~=nil)
	assert(s.isLoc)
	if unit_count()==0 then return true
	else return false
	end	
end

-- проигрыш если убит 1 1 
function fail_cond_hero(s)
	assert(s~=nil)
	assert(s.isLoc)
	if squads[1][1]==nil then return true
	else return false
	end	
end


-- никогда
function cond_false(s)
	assert(s~=nil)
	assert(s.isLoc)
	return false
end

-- проигрыш если пусто на поле или остались только немобильные
function fail_cond_empty(s)
	assert(s~=nil)
	assert(s.isLoc)
	local i,res
	res=true
	for i=1,level_len do
		if units[i]~=nil and not units[i].immobile then 
			res=false 
		end
	end
	return res
end

-- выигрыш елси пусто на радаре
function win_cond_std(s)
	assert(s~=nil)
	assert(s.isLoc)
	if blink[1]+blink[2]==0 then return true
	else return false
	end	
end

-- выигрыш если всех убить
function win_cond_clear(s)
	assert(s~=nil)
	assert(s.isLoc)
	if enemy_count()+blink[1]+blink[2]==0 then return true
	else return false
	end	
end

-- выигрыш если пусто на радаре и взведен флаг или если пусто на радаре и все убиты
function win_cond_stdflag(s)
	assert(s~=nil)
	assert(s.isLoc)
		if (s._win_flag	and blink[1]+blink[2]==0) or (enemy_count()+blink[1]+blink[2]==0)  then
			return true
		else	
			return false
		end			
end

-- выигрыш если взведен флаг
function win_cond_flag(s)
	assert(s~=nil)
	assert(s.isLoc)
	return	s._win_flag
end



-- выигрыш если всех убить и взведен флаг
function win_cond_clearflag(s)
	assert(s~=nil)
	assert(s.isLoc)
	if enemy_count()+blink[1]+blink[2]==0 then return true
	else return false
	end	
end

-- выигрыш если все покинули локацию или все враги уничтожены
function win_cond_escape(s)
	assert(s~=nil)
	assert(s.isLoc)
	local i
	
	if unit_count()==0 then 
		return false 
	end
	
	if enemy_count()+blink[1]+blink[2]==0  then
		return true
	end
	
	for i=1,level_len do
		if units[i] ~= nil then 
			return false
		end
	end	
	
	return true
	
	
end

------------------------------------------------------------
----------------*** описание класса
------------------------------------------------------------

location = function(s) 
		--nam
		s.xdsc	= function(vs)
					local t,i,im,pad
																		
					
					if ui_mode == UI_DEF and m_endturn2._disabled  then t='^^' else t='^' end   --gui.next
					
					pad = 'pad:4 6 0 0,' --впнл
					
					for i = 1,level_len do
					
					t=t..i
					
					--враг слева
						if enemies[1][i] ~= nil then 
							t = t..'{clickenemy(1,'..i..')|'..img(pad..enemies[1][i].img_code(enemies[1][i]))..'}'
						else
							t = t..img(pad..'blank:80x80')
						end
					
					
					--объект слева			
					
						--выбор < >
						if ui_mode == UI_MOV_DIR and i==selected_ny then 
							im='img/'..prefs.thm..'/'..'dir_1.png'
						else
							im = ''
						end

						if locobjs[1][i] ~= nil then 
							t = t..'{clickobj(1,'..i..')|'..img(pad..locobjs[1][i].img_code(locobjs[1][i],i)..';'..im)..'}'  
						else
							if ui_mode == UI_MOV_DIR and i==selected_ny then 						
								t = t..'{clickobj(1,'..i..')|'..img(pad..'blank:80x80;'..im)..'}'
							else
								t = t..img(pad..'blank:80x80;')
							end
						end
						
					--позиция
				
				
						if ui_mode == UI_MOV and selected_pos[i] then 
							im='img/'..prefs.thm..'/'..'x.png'
						elseif ui_mode == UI_SUP and selected_pos[i] then
							im='img/'..prefs.thm..'/'..'sup.png'
						elseif ui_mode == UI_DEF and selected_pos[i] then
							im='img/'..prefs.thm..'/'..'def.png'
						else
							im = ''
						end
				
						if units[i] ~= nil then 						
							t = t..'{clickunit('..i..')|'..img(pad..units[i].img_code(units[i])..';'..im)..'}'						
														
						else
							if selected_pos[i] then t = t..'{clickunit('..i..')|'..img(pad..im)..'}'
							else t = t..img(pad..'img/'..prefs.thm..'/'..'o.png')
							end
						end					
				
						
					--объект справа
						--выбор < >
						if ui_mode == UI_MOV_DIR and i==selected_ny then 
							im='img/'..prefs.thm..'/'..'dir_2.png'
						else
							im = ''
						end

					
						if locobjs[2][i] ~= nil then 
							t = t..'{clickobj(2,'..i..')|'..img(pad..locobjs[2][i].img_code(locobjs[2][i],i)..';'..im)..'}' 			
							

						else
							if ui_mode == UI_MOV_DIR and i==selected_ny then 						
								t = t..'{clickobj(2,'..i..')|'..img(pad..'blank:80x80;'..im)..'}'
							else
								t = t..img(pad..'blank:80x80;')
							end
						end					
					
					
					--враг справа
						if enemies[2][i] ~= nil then 
							t = t..'{clickenemy(2,'..i..')|'..img(pad..enemies[2][i].img_code(enemies[2][i]))..'}'
						else
							t = t..img(pad..'blank:80x80')
						end				

						
					-- следующая строка
						t = t..'^'

						
					end
					
					--t=t..'^'..log;
															
					return t
			end;
		
		s.isLoc = true	
		if s.plan == nil then s.plan={ {}, {}}	end;
		if s.blink == nil then s.blink = {5,5} end;
		if s.level_len == nil then s.level_len = 5 end;	
		if s.timer_events == nil then s.timer_events = {} end;
		if s.random_events == nil then s.random_events = {} end;
		if s.fail_cond == nil then s.fail_cond = fail_cond_std end;
		
		
		
		--тип противников
		if s.enemy_typ==nil then s.enemy_typ={1}; end		
		
		s.entered = function(s)
						--
		end
		
		s.way = { m_help, m_battle_stat, m_radar, m_endturn, m_endturn2};
		
		s.obj = {

				--clickobj
				obj {
						nam='clickobj';
						act=function(s,x,y)
							x=tonumber(x);
							y=tonumber(y);
							local unt
							
							
							if ui_mode == UI_VIEW then
								if locobjs[x][y] ~= nil and locobjs[x][y].isLocobj then --клик для простого просмотра
									locobjs[x][y].click( locobjs[x][y] );
								end
							elseif ui_mode == UI_MOV_DIR and y==selected_ny then --клик по галке выбора направления при движении
								assert(units[selected_y] ~= nil)
								assert(units[selected_y].isUnit)
								
								unt = units[selected_y]
								
								if unt.act_mov( unt,selected_ny,x ) then 
									current_turn[unt._squad ] = UT_MOV 
									
								end

								location_refresh()								
							end							
							
							return true;
						end;
					};
				--clickenemy	
				obj {
						nam='clickenemy';
						act=function(s,x,y)
							x=tonumber(x);
							y=tonumber(y);
							
							if enemies[x][y] == nil then 
								return false;
							elseif enemies[x][y].isEnemy == false then
								return false;
							end
							
							
							if ui_mode == UI_VIEW then
								enemies[x][y].click( enemies[x][y] );						
							elseif ui_mode == UI_AIM and enemies[x][y]._aim then
								assert(units[selected_y] ~= nil)
								assert(units[selected_y].isUnit)
								
								units[selected_y].act_atk( units[selected_y],enemies[x][y]  )
																
								current_turn[units[selected_y]._squad ] = UT_ATK
																			
								location_refresh()
							end							
							
							return true;
						end;
					};
				--clickunit
				obj {
						nam='clickunit';
						act=function(s,y)
							y=tonumber(y);
							local i,done
							
							if ui_mode == UI_VIEW then
								
								if units[y] ~= nil and units[y].isUnit then
									selected_y = y;
									
									units[y].click( units[y] );
								end
							elseif ui_mode == UI_MOV and selected_pos[y] then --выбор x при движении
								ui_mode = UI_MOV_DIR
								selected_ny = y
								deselect_pos()
							elseif ui_mode == UI_SUP and selected_pos[y] and units[y]._sup <MAX_SUP  then --поддержка
								
								units[selected_y].act_sup( units[selected_y], units[y])
								
								current_turn[units[selected_y]._squad ] = UT_SUP
								
								for i = 1,level_len do
									if units[i]~= nil and units[i]._squad == units[selected_y]._squad then 
										units[i]._ready = false
									end	
								end
								
								deselect_pos()
								location_refresh()									
							
							elseif ui_mode == UI_DEF and selected_pos[y] then  --защита
								units[y].act_def(units[y])	
								selected_pos[y] = false				
							
								done = true
								for i = 1,level_len do
									if selected_pos[i] then 
										done = false
									end	
								end
								
								if done then 
									enable(m_endturn2)					
								end
								
								
								inv_clear();
								take( battle_stat )
								
								
								
								--location_refresh() не делаем, все модификаторы сохраняются т.к. бой идет одновременно
								
							end							
							
							return true;
						end;
					};	
	
		
		
				}	
		
		return xroom(s)
			
	end


	
function loc_install(vs)
				assert(vs ~= nil)
				assert(vs.isLoc)
				log = ''			
				blink[1],blink[2] = vs.blink[1],vs.blink[2]
				loc = vs
				if loc.track ~= nil then set_music(loc.track) end
				loc._win_flag = false;
				locobjs = {{},{}};
				level_len = vs.level_len
				local i,j
				for i = 1,level_len do	
					locobjs[1][i] = vs.plan[1][i]  
					locobjs[2][i] = vs.plan[2][i]  
				end
				
				for i = 1,level_len do	for j=1,2 do
					if locobjs[j][i] ~= nil then
						locobjs[j][i]._dir = j
						locobjs[j][i]._pos = i
						
						
						if locobjs[j][i].usable then
							locobjs[j][i]._used = false
							locobjs[j][i]._active = false
						end
						
						
					end			
				end end												
				
				disable(m_endturn2)
				turn = 0 
				endturn()
				
				return true
end

------------------------------------------------------------
---++++++++++++++++++**** рой (класс swarm)
------------------------------------------------------------

--подсчет количества противников
function enemy_count(dir)
	local l,r,i = 0,0
	
	for i=1,level_len do
		if enemies[1][i]~=nil then l=l+enemies[1][i]._size end
		if enemies[2][i]~=nil then r=r+enemies[2][i]._size end	
	end
	
	if dir == nil then
		return l+r
	elseif dir == 1 then
		return l
	else
		return r
	end

end

--обработчик попадания
function swarm_hit(s) 
	assert(s ~= nil)
	assert(s.isEnemy)
	s._size = s._size - 1
	if s._size <= 0 then
		swarm_kill(s)
		return true
	else
		return false
	end	
end

-- убить рой
function swarm_kill(s)
	assert(s~=nil)
	assert(s.isEnemy)
	
	enemies[s._dir][s._pos] = nil	

	delete(s)
	
	
	return true
end

-- убить всех (если dir непусто то всех по одному фронту)
function swarm_kill_all(dir)
	assert(dir==nil or dir==1 or dir==2)
	local i
	
	for i=1,level_len do
		if dir==nil or dir == 1 then 
			if enemies[1][i]~= nil then 
				swarm_kill( enemies[1][i] )
			end
		end	
		if dir==nil or dir == 2 then 
			if enemies[2][i]~= nil then 
				swarm_kill( enemies[2][i] )
			end					
		end	
	end
	
	return true
end

-- атака по бойцам
function swarm_atk_base(s,target)
	assert(s~=nil)
	assert(s.isEnemy)
	assert(target~=nil)
	assert(target.isUnit)
	local rear,d100,lg,ch,fin,dng,med,i
	rear = (s._dir ~= target._dir)
	
	
	lg=''
	
	
	if s.boss then dng = s.danger[prefs.diff] else dng = s.danger[prefs.diff]*s._size  end
	
	
		
	if rear and not target.round_def and not target.armored then 
		ch = norm_chance( dng )
	else
		ch = norm_chance( dng - target.def - target._def )
	end
	
	lg=lg..img('img/'..prefs.thm..'/'..'ico_def.png')..' '..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(target)
	if rear then lg=lg..img('img/'..prefs.thm..'/'..'utrv_defr.png') else  lg=lg..img('img/'..prefs.thm..'/'..'utrv_deff.png') end
	
	lg=lg..s._size..img('img/'..prefs.thm..'/'..'ico_enemy.png')..' ['..flang(s._dir)..s._pos..'] '..ch..'%^'
		
	
	fin = false
	
	repeat
	
		--поиск медика
		med = nil
		if units[s._pos-1]~= nil and units[s._pos-1].medic then
			med = units[s._pos-1]
		elseif units[s._pos+1]~= nil and units[s._pos+1].medic  then
			med = units[s._pos+1]
		else
		end	
	
	
	
		d100 = rnd(100)
		if d100 > ch then 
			lg=lg..img('img/'..prefs.thm..'/'..'ico_def_ok.png') 
			fin = true
		elseif ((rear == false) or ( rear and target.round_def ) )	and target._sup>0 then --при атаке с фронта иможно перекинуть за ОП
				lg=lg..img('img/'..prefs.thm..'/'..'ico_sup.png')
				target._sup = target._sup - 1
		elseif med~=nil and med._sup>0 then --медик
				lg=lg..img('img/'..prefs.thm..'/'..'ico_med.png')
				med._sup = med._sup - 1								
		else --смерть
				lg=lg..img('img/'..prefs.thm..'/'..'ico_killed.png')
				if not s.nonlethal then losses_count = losses_count + 1 end
				unit_kill(target)
				fin = true
		end

	until fin
	
	
	--error(lg)
	
	log  = log..lg..'^'
	return true
	
end

--переключить все метки прицеливания
function aim_all(activ)
	if activ==nil then activ = false end
	local i
	for i =1,level_len do
		if enemies[1][i] ~= nil then enemies[1][i]._aim = activ end
		if enemies[2][i] ~= nil then enemies[2][i]._aim = activ end
	end
	
end

-- расставить метки прицеливания
function aim(pos,dir,range)
	assert(pos~=nil and pos>=0 and pos <= level_len)
	assert(dir ~= nil)
	assert(range ~= nil)
	
	pos = tonumber(pos)
	dir = tonumber(dir)
	range = tonumber(range)
	
	local i
	
	for i = 1,level_len do
		if i>=pos-range and i<=pos+range then
			if enemies[dir][i] ~= nil then enemies[dir][i]._aim = true end
		end
	end

end

-- поиск и ближайшего противника на дистанции dist, возвращает номер позиции куда двигаться, если никого не видит, то случайное
function swarm_find_unit(s)
	assert(s~=nil)
	assert(s.isEnemy)
	
	local i,up,down,res
	up= -1
	down = -1
	
	if units[s._pos] ~= nil then 
		return s._pos
	end
	
	
	--поиск на больших позициях       
	i=s._pos
	while i<=level_len do
		if units[i]~= nil and i-s._pos<=s.observe  then 
			up=i
			break
		end	
		i=i+1
	end	
	
	--поиск на меньших позициях
	i=s._pos
	while i>0 do
		if units[i]~= nil and s._pos-i<=s.observe then 
			down=i
			break
		end	
		i=i-1
	end	
	
	if up==down and up==-1 then --никого не видно
		if s._pos == 1 then 
			res = s._pos + (rnd(s.speed+1) -1)
		elseif s._pos == level_len then
			res = level_len - (rnd(s.speed+1) -1)
		else
			res = s._pos + (rnd(s.speed+1) -1)  *   ( 1 + 2* ( 1-rnd(2))) 
		end	
		
	elseif (up==-1  and down ~=-1 )or ( (up~=-1  and down ~=-1) and    (s._pos - down <= up - s._pos) )  then
		if s._pos - down<=s.speed then 
			res = down
		else
			res = s._pos - s.speed 
		end	
	elseif (down ==-1 and up~=-1) or ((up~=-1  and down ~=-1) and    ( s._pos - down > up - s._pos) ) then
		if up - s._pos <=s.speed then 
			res = up
		else
			res = s._pos + s.speed 
		end		
	else
		error('4570293845')
		
	end

		if res<1 then res =1 end
		if res>level_len then res = level_len end
		return res
	
end

swarm = function(s) 
	if s==nil then s={} end
	if s.nam==nil then s.nam = 'swarm' end
	if s._dir==nil then s._dir = 1 end
	
	s._mov_from = {false,false,false,false,false} --откуда перемещался  {новый, n,s,l,r}
	
	s._aim = false;
	
	
	s.isEnemy = true
	
	s.disp = function(s)
			local t
			t=''
			t=t..imgr('img/'..prefs.thm..'/'..'alien_'..s.picnum..'.png;')
			t=t..txtb(s.nam())..'^^'
			
			if s.boss then 
				t=t..txtb(_l('gui.size')..': ')..'1'..'^'			
				t=t..txtb(_l('gui.stability')..': ')..s._size..'^'						
				t=t..txtb(_l('gui.danger')..': ')..s.danger[prefs.diff]..'%^^'
			else   
				t=t..txtb(_l('gui.size')..': ')..s._size..'^'								
				t=t..txtb(_l('gui.danger')..': ')..s.danger[prefs.diff]*s._size..'%^^'			
		
			end
			
			

			t=t..s.text()
			return t
		end
	
	s.img_code = function(s)
			local im = ''
					--выделение
			if s._selected then 
				im = im..'img/'..prefs.thm..'/'..'light_dr.png;'
			end
			
			im = im..'img/'..prefs.thm..'/'..'alien_'..s.picnum..'.png;'
			
			--размер
			if s._size<10 then im=im..'img/'..prefs.thm..'/'..'ac'..s._size..'.png;' else im=im..'img/'..prefs.thm..'/'..'acA.png;' end 
			--прицеливание
			if s._aim then  
				im=im..'img/'..prefs.thm..'/'..'aim.png'
			end
			
			--перемещение
			if have(radar)~= nil then
				if s._mov_from[1] then im=im..'img/'..prefs.thm..'/'..'from_b.png;' end
				if s._mov_from[2] then im=im..'img/'..prefs.thm..'/'..'from_n.png;' end
				if s._mov_from[3] then im=im..'img/'..prefs.thm..'/'..'from_s.png;' end
				if s._mov_from[4] then im=im..'img/'..prefs.thm..'/'..'from_l.png;' end
				if s._mov_from[5] then im=im..'img/'..prefs.thm..'/'..'from_r.png;' end
			end
			
			
			
			return im
		end
	
	if s.swarm_atk==nil then s.swarm_atk=swarm_atk_base end	
	if s.hit==nil then s.hit=swarm_hit end	
	 
	
	
	return mapobj(s)
end

--добавляет новый рой на поле	
function new_swarm(dir, pos, n, typ)
	assert(dir~=nil)
	assert(pos~=nil and pos>=0 and pos <= level_len)
	assert(n~=nil)
	assert(typ~=nil)
	pos = tonumber(pos)
	dir = tonumber(dir)
	n = tonumber(n)
	typ = tonumber(typ)
	
	local sw = new('swarm_'..typ..'()')
	sw._size = n;
	sw._dir = dir;
	sw._pos = pos
	enemies[dir][pos] = sw
	return true;
end	
	
--переместить рой с рассчетом добавления или обмена позициями	
function swarm_mov(s,dir,pos) 
	assert(s~=nil)
	assert(s.isEnemy)
	assert(dir~=nil)
	assert(pos~=nil and pos>=0 and pos <= level_len, s._dir..'-'..s._pos..'-'..dir..'-'..pos)	
	
	if not s._ready then return false end
	
	if s._dir == dir and s._pos == pos then return true end
	
	local tmp,old_dir,old_pos
	
	
	--позиция с которой уходим
	old_dir = s._dir
	old_pos = s._pos
	
	if enemies[dir][pos] == nil then --переход на свободную позицию
		enemies[dir][pos] = s
		enemies[old_dir][old_pos] = nil
		s._dir = dir
		s._pos = pos
		s._ready = false
		radar_log = radar_log..''..img('img/'..prefs.thm..'/'..'ico_enemy.png')..s._size..' '..flang(old_dir)..old_pos..img('img/'..prefs.thm..'/'..'utrv_mov.png')..flang(dir)..pos..'^ '
	elseif enemies[dir][pos].typ == s.typ then --слияние
		enemies[dir][pos]._size = enemies[dir][pos]._size + s._size
		delete(enemies[old_dir][old_pos])
		enemies[old_dir][old_pos] = nil
		radar_log = radar_log..''..img('img/'..prefs.thm..'/'..'ico_enemy.png')..s._size..' '..flang(old_dir)..old_pos..img('img/'..prefs.thm..'/'..'utrv_mov.png')..flang(dir)..pos..img('img/'..prefs.thm..'/'..'utrv_union.png')..'^ '
	else --обмен позициями
		tmp = enemies[dir][pos] --тот с кем меняемся
		enemies[dir][pos] = s
		enemies[old_dir][old_pos] = tmp
		tmp._dir = old_dir
		tmp._pos = old_pos
		s._dir = dir
		s._pos = pos
		s._ready = false
		tmp._ready = false	
		radar_log = radar_log..''..img('img/'..prefs.thm..'/'..'ico_enemy.png')..s._size..' '..flang(old_dir)..old_pos..img('img/'..prefs.thm..'/'..'utrv_chg.png')..flang(dir)..pos..'^ '
	end

	
	--ставим отметку перемещения
	if dir>old_dir then 
		enemies[dir][pos]._mov_from[4] = true
	elseif 	dir<old_dir then 
		enemies[dir][pos]._mov_from[5] = true
	elseif pos>old_pos then
		enemies[dir][pos]._mov_from[2] = true
	elseif pos<old_pos then
		enemies[dir][pos]._mov_from[3] = true
	else
	end
	

	
end
	
------------------------------------------------------------
---++++++++++++++++++**** отряд (функции работы со списком squads)
------------------------------------------------------------	
--текущее количество бойцов
function unit_count() 
	return squad_size(1)+squad_size(2)+squad_size(3)
end

--стереть все данные из сквада
function squads_clear()
	local i,j
	for i=1,3 do for j=1,3 do
		reinforcement[i][j] = false
		if squads[i][j] ~= nil then
			delete(squads[i][j])
			squads[i][j] = nil
		end
	end end
	for i=1,size(graveyard) do 
		delete(graveyard[i])
	end 
	graveyard = {}
	
end

--удалить всех бойцов с поля
function units_clear()
	local i
	for i=1,level_len do 
			units[i] = nil
	end 
end

function squads_disembark()
	local i,j,k, un
	un = {}
				
	for i=1,3 do 
		for j=1,3 do
			if squads[i][j] ~= nil then
				table.insert(un,squads[i][j])
			end			
		end	
		last_turn[i] = nil
		current_turn[i] = nil
	end
	
	for i=1,level_len do
		units[i]=nil
	end
	
	
	
	j = size(un) 
	if 	j>level_len then
		j=level_len
	end
	for i=1,j do
		k 	= rnd( size(un) )
		
		disembark( un[k], rnd(2),level_len-i+1  )
		un[k]._ready = true;
		table.remove(un,k)
		
		
	end
	
end	
	
------------------------------------------------------------
---++++++++++++++++++**** боец (класс unit)
------------------------------------------------------------
----------------*** списки констант
------------------------------------------------------------

grade_list = 
{	[0] = function() return _l('gui.grade0') end,
	[1] = function() return _l('gui.grade1') end,
	[2] = function() return _l('gui.grade2') end,
	[3] = function() return _l('gui.grade3') end,
	[4] = function() return _l('gui.grade4') end,
	[5] = function() return _l('gui.grade5') end,
	[6] = function() return _l('gui.grade6') end,
	[7] = function() return _l('gui.grade7') end,
	[8] = function() return _l('gui.grade8') end,
	[9] = function() return _l('gui.grade9') end, 	
	[10] = function() return _l('gui.grade10') end, 	
	[11] = function() return _l('gui.grade11') end,
	[12] = function() return _l('gui.grade12') end,
	[13] = function() return _l('gui.grade13') end,
	[14] = function() return _l('gui.grade14') end,
	[15] = function() return _l('gui.grade15') end,
	[16] = function() return _l('gui.grade16') end,
	[17] = function() return _l('gui.grade17') end,
	[18] = function() return _l('gui.grade18') end,
	[19] = function() return _l('gui.grade19') end,

}	

	ARM_SPACEINF = 1
	ARM_LOC = 2
	ARM_COL = 3
	
army_list =
{   [ARM_SPACEINF] = function() return _l('gui.army1') end, -- 'Космическая пехота',
	[ARM_LOC] = function() return _l('gui.army2') end, -- 'Силы самообороны'
	[ARM_COL] = function() return _l('gui.army3') end -- 'Колонисты'  
}

CAT_REG = 1
CAT_TKT = 2
CAT_SPEC = 4
CAT_ASLT = 5
CAT_TECH = 6

COL_TEC = 7
COL_SCN = 8
category_list = 
{	[CAT_REG] = function() return _l('gui.category1') end,--'Регулярный',
	[CAT_TKT] = function() return _l('gui.category2') end,--'Огневая поддержка',
	[CAT_SPEC] = function() return _l('gui.category4') end,--'Специальный',
	[CAT_ASLT] = function() return _l('gui.category5') end,--'Штурмовой',
	[CAT_TECH] = function() return _l('gui.category6') end,--'Техника'
	
	[COL_TEC] = function() return _l('Технический персонал') end,--'Технический персонал'
	[COL_SCN] = function() return _l('Ученые') end--''
	
}

------------------------------------------------------------
----------------*** вспомогательные функции
------------------------------------------------------------

-- фишечки
list_nation = {
'русский',
'японец',
'француз'
}

-- list_name[пол][происхождение]

list_name = {
--1 Мужские имена
{	--1 Русские
	{'Александр','Алексей','Анатолий','Андрей','Антон','Артур','Борис','Вадим','Валентин','Виктор','Виталий','Вячеслав','Георгий','Григорий','Герман','Геннадий','Денис','Дмитрий','Евгений','Захар','Иван','Игорь','Кирилл','Константин','Лев','Леонид','Максим','Михаил','Никита','Олег','Павел','Петр','Роман','Семен','Сергей','Тарас','Тимур','Федор','Эдуард','Юрий','Яков'},
	--2 Японские
	{'Акира','Ахато','Бодо','Горо','Даики','Дзюндзи','Ёдзи','Ёсиаки','Ёсио','Ёсихару','Каито','Кадзуси','Кадзухиро','Кимио','Масааки','Масахиро','Мицуру','Наоки','Нобуо','Осаму','Рюсукэ','Рэидзи','Сатоси','Сигэхару','Синдзи','Такао','Такэси','Такахиро','Тэцуо','Тосиаки','Томохиро','Уйтиро','Фуюки','Хадзимэ','Хаятэ','Хидэаки','Хидэки','Хироаки','Хироми','Юки','Юдзи','Ясуси','Ясухару'},
	--3 Французские
	{'Адриан','Амори','Арно','Бастиан','Бернард','Вивьен','Гильберт','Готье','Дени','Джереми','Доминик','Жан','Жюль','Илберт','Камиль','Клод','Константен','Лазар','Луи','Люк','Марк','Матис','Моррис','Николя','Оливье','Персиваль','Рауль','Реми','Ренард','Сильвен','Теодор','Тирри','Фабрис','Фабьен','Франк','Хамнет','Эдгард','Этьенн'}
},
--2 Женские имена
{ 
	--1 Русские
	{'Валентина','Карина','Полина','Валерия','Кира','Вера','Кристина','Александра','Вероника','Лариса','Алина','Виктория','Лидия','Светлана','Алиса','Алла','Галина','Любовь','Софья','Людмила','Анастасия','Дарья','Майя','Ангелина','Диана','Маргарита','Тамара','Анжелика','Ева','Мария','Татьяна','Анна','Евгения','Марина','Антонина','Екатерина','Елена','Милена','Эльвира','Елизавета','Надежда','Наталья','Зинаида','Нелли','Юлия','Зоя','Нина','Инна','Оксана','Яна','Ирина','Олеся','Ольга'}
	},
	--2 Японские
	{'???'},
	--3 Французские
	{'???'}
}

--list_last[происхождение]
list_last = {
	--1 русские (отбор для ж = м..'а')
    {'Абрамов','Александров','Алексеев','Афанасьев','Балакин','Белов','Бондарев','Вершинин','Виноградов','Волков','Воронов','Голубев','Горев','Громов','Гусев','Дегтярев','Дежнёв','Должиков','Дубов','Евграфов','Ежов','Ельцов','Ермаков','Ерофеев','Жуков','Задоржный','Зимин','Золин','Зубов','Иванов','Ильин','Касьянов','Кашин','Князев','Ковалёв','Костин','Котов','Круглов','Кузнецов','Купцов','Ларов','Ларин','Летов','Любимов','Макаров','Максимов','Малышев','Морозов','Новиков','Новосельцев','Носков','Носов','Огурцов','Озеов','Орлов','Петров','Петухов','Поздняков','Попов','Рощин','Ремизов','Рубцов','Семёнов','Сёмин','Соболев','Соколов','Степанов','Табаков','Тихомиров','Токарев','Туполев','Угольников','Фокин','Фролов','Харитонов','Хромов','Царев','Черепанов','Чернов','Шишкин','Шестаков','Юсупов','Яковлев'},
	--2 японские
	{'Сато','Судзуки','Такахаси','Танака','Ватанабэ','Ито','Ямамото','Накамура','Кобаяси','Като','Ёсида','Ямада','Сасаки','Ямагути','Саито','Мацумото','Иноэ','Кимура','Хаяси','Симидзу','Ямадзаки','Мори','Абэ','Икэда','Хасимото','Ямасита','Исикава','Накадзима','Маэда','Фудзита','Огава','Гото','Окада','Хасэгава','Мураками','Кондо','Исий','Саито','Сакамото','Иендо','Аоки','Фудзии','Нисимура','Фукуда','Оота','Миура','Окамото','Мацуда','Накагава','Накано','Харада','Фудзивара','Оно','Тамура','Такэути','Канэко','Вада','Накаяма','Исида','Уэда','Морита','Хара','Сибата','Сакаи','Кудо','Ёкояма','Миядзаки','Миямото','Утида','Такаги','Андо','Танигути','Ооно','Маруяма','Имаи','Такада','Фудзимото','Такэда','Мурата','Уэно','Сугияма','Масуда','Сугавара','Хирано','Ооцука','Кодзима','Тиба','Кубо','Мацуи','Ивасаки'},
	--3 Французские
	{'Марта','Бернар','Тома','Пети','Робер','Ришар','Дюран','Дюбуа','Моро','Лоран','Симон','Мишель','Лефебвр','Лероа','Ру','Дави','Бертран','Морель','Фурньер','Жирар','Бонне','Дюпон','Ламбрт','Фонтэн','Руссо','Винсен','Мюллер','Лефевр','Форе','Андре','Мерсьер','Блан','Гюра','Бойер','Гарньер','Шевальер','Франсоа','Легранд','Готьер','Гарсия','Перра','Роба','Клемен','Мора','Николя','Энри','Руссель','Мэтье','Готьер','Массо','Маршанд','Дюваль','Дени','Дюмон','Мари','Энри','Руссель','Матье','Дюфур','Меньер','Брюн','Бланшар','Жиро','Жоли','Ривьер','Люка','Брюне','Гайлар','Барбьер','Арно','Мартинез','Жерар','Рош','Ренар','Смит','Роа','Леру','Коля','Вида','Каро','Пикар','Рожер','Фабре','Обе','Лемоан','Рено','Дюма','Лакроа','Оливиер','Филирр','Буржеоа','Пиерр','Беноа'}
}

function unit_lifepath(s,sex,nation,nam,lastn)
	assert(s~=nil)
	assert(s.isUnit)
	if sex==nil then 
		sex=rnd(2)
	end		
	if nation == nil then 
		nation = rnd(size(list_nation)) 
	end

	assert( nation>0 and nation <= size(list_nation) ) 
	assert( sex==1 or sex==2 ) 


	if nam == nil then 
		nam = rnd(  size( list_name[sex][nation] ) )
	end	
	if lastn == nil then 
		lastn = rnd(  size( list_last[nation] ) )
	end	
	
	s._sex = sex
	s._nation=nation
	s._name = nam
	s._last = lastn

end

function unit_fio(s)
	assert(s~=nil)
	assert(s.isUnit)
	return list_name[s._sex][s._nation][s._name]..' '..list_last[s._nation][s._last]	
	
end

function unit_upgrade(s,new_class)
	assert(s~=nil)
	assert(s.isUnit)
	assert(new_class~=nil)

	local upg
	upg = new_unit(new_class, s._squad,s._num)
	upg._sex = s._sex;
	upg._nation = s._nation
	upg._name = s._name
	upg._frag = s._frag
	upg._def_count = s._def_count
	upg._ready = s._ready
	upg._sup = s._sup
	disembark(upg,s._dir,s._pos)
	
	delete(s)	
	return upg
	
end

--снять метки смены позиции
function deselect_pos()
	selected_pos = {}
end

--установить метки смены позиции, значения mode 
--		если sup_mode то метка ставится только на поле с бойцом
--		если mov_mode то метка не ставится на поле с немобильным бойцом (кроме себя)
function select_pos(pos,mov, mode )
	pos = tonumber(pos)
	mov = tonumber(mov)
	assert(pos~=nil and pos>=0 and pos <= level_len)
	assert(mov~=nil and mov>=0)

	
	local i
	
	for i = 1,level_len do
		if i>=pos-mov and i<=pos+mov then
			if mode == 'sup_mode' then
				if units[i] ~= nil and i ~= selected_y and units[i]._sup < MAX_SUP then 
					selected_pos[i]=true 
				end
			elseif mode == 'mov_mode' then
				if  units[i] ~= nil and units[i].immobile and i~=pos then 
					selected_pos[i] = false 
				else
					selected_pos[i]=true 
				end				
			else
				selected_pos[i]=true 
			end	
		else
			selected_pos[i] = false 
		end
	end
end	

--возвращает врага спереди	и с тыла
unit_enemy_f = function(vs)
			assert(vs~=nil)
			assert(vs.isUnit)
			return enemies[vs._dir][vs._pos]	
		end;
unit_enemy_r = function(vs)
			assert(vs~=nil)
			assert(vs.isUnit)
			local d
			if vs._dir == 1 then d=2 else d=1 end
			return enemies[vs.d][vs._pos]
		end;
--возвращает объект спереди и с тыла
unit_obj_f = function(vs)
			assert(vs~=nil)
			assert(vs.isUnit)
			return locobjs[vs._dir][vs._pos]	
		end;
unit_obj_r = function(vs)
			assert(vs~=nil)
			assert(vs.isUnit)
			local d
			if vs._dir == 1 then d=2 else d=1 end
			return locobjs[vs.d][vs._pos]
		end;		
		

--поместить бойца на позицию
function disembark(unit,dir, pos )
	assert(unit~=nil)
	assert(unit.isUnit)
	assert(pos>=1 and pos<=level_len)
	if dir==nil then dir = rnd(2) end
	assert(dir==1 or dir==2)
	
	units[pos]=unit
	unit._pos = pos
	unit._dir = dir
	
end;

--возвращает код типа К-1
function get_unit_label(s)
			assert(s~=nil)
			assert(s.isUnit)			
			local t=''
			if s._squad == 1 then 
				t=t..'К-'
			elseif s._squad == 2 then
				t=t..'С-'
			else
				t=t..'Ж-'
			end
			t=t..s._num
			return t
end

--текущее количество бойцов в отряде номер squad
function squad_size(squad) 
	assert(squad~=nil and squad>0 and squad<4)
	local i,c
	c=0;
	for i=1,3 do
		if squads[squad][i] ~= nil then c=c+1 end
	end
	return c		
end

--создать нового бойца
function new_unit(class,squad,num) 
	assert(class~=nil)
	squad=tonumber(squad)
	num = tonumber(num)
	assert(squad>0 and squad<4)
	assert(num>0 and num<4)
	
	local o,n
	o = new(class..'()')

	o._squad = squad
	o._num = num
	
	
	n= rnd(2)	--50% русские
	if n==2 then n=rnd(2)+1 end
	
		
	unit_lifepath(o,1,n )	
		
	squads[squad][num] = o
	return o;
	
end

------------------------------------------------------------
----------------*** активные пункты меню справа
------------------------------------------------------------

-- активный пункт меню с атакой бойца
m_atk = menu {
	nam = 'Атака',
	disp = function(s) return img('img/'..prefs.thm..'/'..'ico_atk.png')..' '.._l('gui.atk') end,
	menu = function(s)
		local t =''
		local y = selected_y
		ui_mode = UI_AIM
		aim(selected_y, units[selected_y]._dir, units[selected_y].range)  

		if  units[y] ~= nil and units[y].isUnit then
			if units[y].text_atk ~=nil and units[y].text_atk()~=nil then t=t..'^^'..units[y].text_atk() end 
		end
		
		inv_clear();
		take_my_stat(_l('gui.atk2')..t..'^')
		take(m_back);
		--для перерисовки
		walk(loc)
		
	end
}

m_mov = menu {
	nam = 'Движение',
	disp = function(s) return img('img/'..prefs.thm..'/'..'ico_mov.png')..' '.._l('gui.mov') end,
	menu = function(s)
		local t =''
		local y = selected_y
		local unt
		
		if units[y] ~= nil and units[y].isUnit then unt = units[y]
		else error('')
		end
			
		ui_mode = UI_MOV
	
		select_pos(y, norm_dist(unt.mov+unt._mov),'mov_mode'  )
		--select_pos(3,1)
		
		if unt.text_mov~=nil and unt.text_mov()~=nil then t=t..'^^'..t..unt.text_mov() end 
		
		
		inv_clear();
		take_my_stat(_l('gui.mov2')..t..'^')
		take(m_back);
		--для перерисовки
		walk(loc)
		
	end
}

m_sup = menu {
	nam = 'Поддержка',
	disp = function(s) return img('img/'..prefs.thm..'/'..'ico_sup.png')..' '.._l('gui.sup') end,
	menu = function(s)
		local t =''
		local y = selected_y
		
		local unt
		
		
		if units[y] ~= nil and units[y].isUnit then unt = units[y]
		else error('')
		end
		
		unt = units[y]
		ui_mode = UI_SUP
		select_pos(y, norm_dist(unt.mov+unt._mov), 'sup_mode' )
		
		if unt.text_sup~=nil and unt.text_sup()~=nil then t=t..'^^'..t..unt.text_sup()..'^' end
		
		inv_clear();		

		take_my_stat(_l('gui.sup2')..t..'^')
		take(m_back);
		--для перерисовки
		walk(loc)

			
			
		return true
		
		
		
	end
}

m_panic = menu {
	nam = 'Поддержка',
	disp = function(s) return img('img/'..prefs.thm..'/'..'ico_none.png').._l('gui.panic') end,
	
}

-- активный пункт меню с отменой действия
m_back = menu {
	nam = 'Назад',
	disp = function(s) return img('img/'..prefs.thm..'/'..'ico_no.png').._l('gui.back') end,
	menu = function(s)
				local y = selected_y
				if units[y] ~= nil and units[y].isUnit then
					aim_all(false);
					deselect_pos();
					
					ui_mode = UI_VIEW 
					units[y].click( units[y] );
					
					return true
					
				else
					error('')
					return false
				end		
		end
}

--описание в меню справа в режиме боя или при наборе	
unit_disp = function(s)
			assert(s~=nil)
			assert(s.isUnit)
			local t,txt,c
			txt=''
			t=''
			t=t..imgr('img/'..prefs.thm..'/'..'u_'..s.code..'_l.png')
			t=t..txtb(s.nam())..'^'
			
			if s._mov == 0 then	
				t = t..txtb(_l('gui.statmov')..': ')..s.mov..'^'	
			else
				if s._mov>0 then c='+'..s._mov else c=s._mov end
				t = t..txtb(_l('gui.statmov')..': ')..norm_dist(s.mov+s._mov)..' ('..c..')^'	
			end
			
			if s._range == 0 then	
			t = t..txtb(_l('gui.statrange')..': ')..s.range..'^'
			else
				if s._range>0 then c='+'..s._range else c=s._range end
				t = t..txtb(_l('gui.statrange')..': ')..norm_dist(s.range+s._range)..' ('..c..')^'	
			end
			if s._acc == 0 then				
			t = t..txtb(_l('gui.statacc')..': ')..s.acc..'%^'	
			else
				if s._acc>0 then c='+'..s._acc else c=s._acc end
				t = t..txtb(_l('gui.statacc')..': ')..s.acc+s._acc..'%'..' ('..c..'%)^'	
			end
			if s._def == 0 then				
			t = t..txtb(_l('gui.statdef')..': ')..s.def..'%^^'
			else
				if s._def>0 then c='+'..s._def else c=s._def end
				t = t..txtb(_l('gui.statdef')..': ')..norm_dist(s.def+s._def)..'% ('..c..'%)^^'	
			end
			
			
			t = t..unit_fio(s)..'^'
			
			t = t..'  '..army_list[s.army]()..'  ^'
			
			
			if ui_mode ~= UI_RECRUIT then
				if s._squad == 1 then 
					t=t.._l('gui.redsq')..', '
				elseif s._squad == 2 then
					t=t.._l('gui.bluesq')..', '
				else
					t=t.._l('gui.yellowsq')..', '
				end
				t=t.._l('gui.num')..' '..s._num..'^'			
			end	
			
			
			
			t = t..txtb(_l('gui.grade')..': ')..grade_list[s.grade]()..'^'
			t = t..txtb(_l('gui.category')..': ')..category_list[s.category]()..'^^'	

			
			if s.text_atk ~=nil and s.text_atk()~=nil and s.text_atk()~='' then t=t..'*'..s.text_atk()..'^' end 
			if s.text_mov ~=nil and s.text_mov()~=nil and s.text_mov()~='' then t=t..'*'..s.text_mov()..'^' end
			if s.text_sup ~=nil and s.text_sup()~=nil and s.text_sup()~='' then t=t..'*'..s.text_sup()..'^' end
			if s.text_add ~=nil and s.text_add()~=nil and s.text_add()~='' then t=t..'*'..s.text_add()..'^' end
			if s.text_def ~=nil and s.text_def()~=nil and s.text_def()~='' then t=t..'*'..s.text_def()..'^' end

			

			return t
		end

------------------------------------------------------------
----------------*** базовые методы класса атака, движение, поддержка, защита
------------------------------------------------------------

--базовая стрельба rounds-повторов в стрельбе  dmg - для рассчета взрывов, сколько максимум поражает за раз
unit_act_atk_base = function(s,target,rounds, dmg)
			assert(s~=nil)
			assert(s.isUnit)
			assert(target~=nil)
			assert(target.isEnemy)
			assert(rounds>0)
			if dmg==nil then dmg = 1 end;
			
			
			local d100,lg,i,fin,d			
			lg=''		
			
			lg = lg..''..img('img/'..prefs.thm..'/'..'ico_atk.png')..' '..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(s)..' ['..flang(s._dir)..s._pos..img('img/'..prefs.thm..'/'..'utrv_atk.png')..flang(target._dir)..target._pos..'] '.._l('gui.prognosis')..' '..norm_chance(s.acc + s._acc)..'%^'.._l('gui.enemy')..': '
			
			for i=1,target._size do lg = lg..img('img/'..prefs.thm..'/'..'ico_enemy.png') end
			
			lg = lg..'^'.._l('gui.hits')..': '			
			
			if s._ready==false and s._sup>0 and s.single_atk == false then 
			rounds=1 
			end

			
			i,fin=1,false
			while i <=rounds and not fin  do
				d100=rnd(100)			
				if d100<= norm_chance(s.acc + s._acc) and target._size>0 then 
						for d=1,dmg do	
					
							lg= lg..img('img/'..prefs.thm..'/'..'ico_hit.png')
							
							if not target.human then 
								s._frag = s._frag+1 
								if not target.nonlethal then frag_count = frag_count+1 end
							elseif target.human then
								s._frag = s._frag+1
								hm_count = hm_count +1
							end
							
							
							if swarm_hit(target) then 
								lg=lg..'^'.._l('gui.enemydown')
								fin = true
								break
							end							
						end --for d
				else
					lg= lg..img('img/'..prefs.thm..'/'..'ico_miss.png')
				end	
				
				i=i+1
				
			end	

			lg =lg..'^'		
			
			if s._ready then
				s._ready = false
			elseif s._sup>0 and s.single_atk == false and ui_mode~= UI_DEF and current_turn[s._squad] ~= UT_MOV then	 	
				s._sup = s._sup-1
			end	
			
			log_add(lg)
			return true
			
	end

unit_act_atk = function(s,target)
		unit_act_atk_base(s,target,1)
		if s.snd_atk ~=nil then add_sound(s.snd_atk,1,1) end
		end;

unit_act_atk1_5 = function(s,target)
		unit_act_atk_base(s,target,1,5)
		if s.snd_atk ~=nil then add_sound(s.snd_atk,1,1) end
		end;		
		
unit_act_atk2 = function(s,target)
		unit_act_atk_base(s,target,2)
		
		if s.snd_atk ~=nil then add_sound(s.snd_atk,1,1) end
		
		return true
			
		end;

unit_act_atk3 = function(s,target)
		unit_act_atk_base(s,target,3)
		if s.snd_atk ~=nil then add_sound(s.snd_atk,1,1) end
		return true
			
		end;		

unit_act_mov = function(s,pos,dir)
		pos = tonumber(pos)
		assert(pos~=nil and pos>=0 and pos <= level_len)
		dir = tonumber(dir)
		assert(dir ==1 or dir==2)
		assert(s~=nil)
		assert(s.isUnit)
		
		
		if s.snd_mov ~= nil then  add_sound(s.snd_mov) end;
		
		local unt,last_pos,lg
		lg=''

		unt = units[pos]
		last_pos = s._pos
		last_dir = s._dir
		
		disembark(s,dir,pos)
		if unt~=nil then --обмен местами
			disembark(unt,unt._dir,last_pos) 
			lg = lg..img('img/'..prefs.thm..'/'..'ico_mov.png')..' '..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(s)..img('img/'..prefs.thm..'/'..'utrv_chg.png')..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(unt)..''..' ['..flang(last_dir)..last_pos..img('img/'..prefs.thm..'/'..'utrv_chg.png')..flang(dir)..pos..']'

			
		else --перемещение
			units[last_pos]=nil 
			lg = lg..img('img/'..prefs.thm..'/'..'ico_mov.png')..' '..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(s)..' ['..flang(last_dir)..last_pos..img('img/'..prefs.thm..'/'..'utrv_mov.png')..flang(dir)..pos..']^'
		end
				
		s._ready = false;
		
		if locobjs[dir][pos] ~= nil and locobjs[dir][pos].usable then  locobjs[dir][pos]._activ = true; end
		
		
		log_add(lg)	
		return true	
end

unit_act_sup = function(s,target)
	assert(s~=nil)
	assert(s.isUnit)
	assert(target~=nil)
	assert(target.isUnit)
	local unt,last_pos,lg
	lg=''
	
	if target._sup<5 then 
		target._sup = target._sup + 1 
		s._ready = false;
		lg=lg..img('img/'..prefs.thm..'/'..'ico_sup.png')..' '..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(s)..img('img/'..prefs.thm..'/'..'utrv_sup.png')..img('img/'..prefs.thm..'/'..'utrv_man.png')..get_unit_label(target)..' ('.._l('gui.sp')..'+1)' 
	else
		lg=lg..img('img/'..prefs.thm..'/'..'ico_sup.png')..get_unit_label(s)..img('img/'..prefs.thm..'/'..'utrv_sup.png')..get_unit_label(target)..' ['..s._pos..img('img/'..prefs.thm..'/'..'utrv_sup.png')..target._pos..']^'  
		lg=lg.._l('gui.noneedsp')
	end
	
	log_add(lg)	
	return true
	
end

unit_act_def = function(s)
	assert(s~=nil)
	assert(s.isUnit)
	s._def_count = s._def_count+1
	
	
	local d100,lg,i,ef,er,inic,rear			
	lg=''		
	
	if s._dir == 1 then 
		ef = enemies[1][s._pos]
		sf=1
		er = enemies[2][s._pos]
		sr=2		
	else	
		ef = enemies[2][s._pos]
		sf=2
		er = enemies[1][s._pos]	
		sr=1
	end
	
	--lg=lg..'^'
	
	log_add(lg)
	
	inic={}
	--если атака с двух сторон первым атакует наибольший рой, если равны то с тыла
    if ef ~= nil and er ~= nil  then
		if ef._size > er._size then 
			inic[1] = ef 
			inic[2] = er
		else
			inic[1] = er 
			inic[2] = ef
		end	
	elseif ef ~= nil then
		inic[1] = ef 
	elseif er ~= nil then
		inic[1] = er 
	else
	end

	
	if size(inic)>0 then 
		if s.snd_def ~=nil then add_sound(s.snd_def,1,1) end
		for i=1,size(inic) do
			inic[i].swarm_atk(inic[i],s)
			if s._killed then
				break
			end
		end
	end

	
	return true
end

--убить бойца
function unit_kill(s)
	assert(s~=nil)
	assert(s.isUnit)	
	
	s._killed = true
	
	units[ s._pos ]	= nil
	squads[ s._squad ][s._num] = nil
	table.insert( graveyard, s )
	
	return true
end

-- свободный клик в режиме боя
unit_click = function(s)
			assert(s~=nil)
			assert(s.isUnit)

			mapobj_click(s)
			
			if s._ready then
				
				if s.snd_sel ~=nil then add_sound(s.snd_sel) end
			
				if current_turn[s._squad] ~= nil then
					if current_turn[s._squad] == UT_ATK then take(m_atk) 
					elseif current_turn[s._squad] == UT_MOV then take(m_mov) 
					--elseif current_turn[s._squad] == UT_SUP then take(m_sup) --поддержку использует только один из группы
					else
					end
				else
				
					if last_turn[s._squad] ~= UT_ATK and not s.unarmed  then take(m_atk)  end
					if last_turn[s._squad] ~= UT_MOV then take(m_mov)  end
					if last_turn[s._squad] ~= UT_SUP then take(m_sup)  end
				
			
				end
			
			elseif  s.single_atk  then --запрещен повтор атаки

			elseif current_turn[s._squad] == UT_ATK and s._sup >0  then	--уже ходил но возможен повтор атаки
				take(m_atk) 
			elseif current_turn[s._squad] == UT_PANIC then	
				take(m_panic) 

			
			end
			
		return	true
			
		end

	
	
----------------*** класс unit
unit = function(s)
	
	if s._sup==nil then s._sup = 0; end;
	if s._pos==nil then s._pos = 0; end;
	if s._dir==nil then s._dir = 1; end;
	if s.loner==nil then s.loner = false end; -- одиночка, не может поддерживать
	if s.single_atk==nil then s.single_atk=false end;   -- не может повторять атаки за ОП
	if s.round_def==nil then s.round_def=false end;   -- защищается от атак с тыла так же как с фронта
	
	--поддержка
	s._sup = 0
	
	--модификаторы
	s._mov = 0;
	s._range = 0;
	s._acc = 0;
	s._def = 0;
	
	--статистика
	s._frag = 0;
	s._def_count = 0;
	
		
	s._ready = true;
	
	s.isUnit = true;

	

--выбор при просмотре	
	s.click = unit_click

	s.disp = unit_disp 
		
	s.img_code = function(s)
		assert(s~=nil)
		assert(s.isUnit)
		local im, k
		im = ''
		k = ''

		--карта
		--im = im..'img/'..prefs.thm..'/'..'card_u.png;'
		
		--выделение
		if s._selected then 
			im = im..'img/'..prefs.thm..'/'..'light_g.png;'
		end
		
		--силуэт
		if not s._ready then k='_n' end
		
		im = im..'img/'..prefs.thm..'/'..'u_'..s.code..'_'
		if s._dir == 1 then
			im = im..'l'
		else
			im = im..'r'
		end		
		im=im..k..'.png;'
		
		--звено
		im=im..'img/'..prefs.thm..'/'..'z_'..s._squad..s._num..'.png;'	
		
		--поддержка
		if s._sup > 0 then 
		im=im..'img/'..prefs.thm..'/'..'support_'..s._sup..'.png;'
		end
		
		--метка текущего хода
		
		if current_turn[s._squad] ~= nil then
			if current_turn[s._squad] == UT_ATK then
				im=im..'img/'..prefs.thm..'/'..'act_atk.png;'
			elseif current_turn[s._squad] == UT_SUP then
				im=im..'img/'..prefs.thm..'/'..'act_sup.png;'
			elseif current_turn[s._squad] == UT_MOV then
				im=im..'img/'..prefs.thm..'/'..'act_mov.png;'
			elseif current_turn[s._squad] == UT_PANIC then
				im=im..'img/'..prefs.thm..'/'..'act_none.png;'
			else
			end
			

			
		end
		
	
		
		return im
	end
	
--вызывается при атаке
	if s.act_atk == nil then s.act_atk = unit_act_atk end
--вызывается при движении
	if s.act_mov == nil then s.act_mov = unit_act_mov end
--вызывается при необходимости поддержки кого-то
	if s.act_sup == nil then s.act_sup = unit_act_sup end	
--вызывается при защите
	if s.act_def == nil then s.act_def = unit_act_def end		
--вызывается в начале нового хода
	if s.act_turn == nil then s.act_turn = unit_act_turn end		
	
	
	
	return mapobj(s)
end

--------------------------------------
---++++++++++++++++++**** промежуточный квест\текст  (класс quest)
--------------------------------------

quest = function(s)
	s.isQuest = true
	return xroom(s)
end

--------------------------------------
---++++++++++++++++++**** миссия (класс mission) и переходные экраны
--------------------------------------
--статистика по всем юнитам
function units_stat()
		local t,i,j
		t=''

		if unit_count() == 0 then 
			t=t..'*'.._l('gui.alldown')..'^'
		else
			t=t..'*'.._l('gui.survivors')..'^'
			for i=1,3 do for j=1,3 do
				if squads[i][j] ~= nil then
					t=t..get_unit_label(squads[i][j])..': '..unit_fio(squads[i][j])..', '..squads[i][j].nam()..' ('..squads[i][j]._frag..'/'..squads[i][j]._def_count..')^' 
				end	
			end end
		end
		
		t=t..'^'..'*'.._l('gui.casualties')..'^'
	
		if size(graveyard)==0 then 
		t=t.._l('gui.no')..''
		else		
			for i=1,size(graveyard) do
				t=t..get_unit_label(graveyard[i])..': '..unit_fio(graveyard[i])..', '..graveyard[i].nam()..' ('..graveyard[i]._frag..'/'..graveyard[i]._def_count..')^' 
			end
		end
			
		return t	
end

--информация о человеке
function file_info()
	local t
			t=''
			t = t.._l('gui.name')..': '.._l(hero.fio)..'^'.._l('gui.age')..': '..hero.age..'^'.._l('gui.grade')..': '..grade_list[hero.grade]()

			if hero.grade == 0 then -- гражданский
				t = t..'^'.._l('gui.dep')..': '.._l(hero.army)..'^'.._l('gui.prof')..': '.._l(hero.vus)..'^'
			else --военный
				t = t..'^'.._l('gui.army')..': '.._l(hero.army)..'^'.._l('gui.vus')..': '.._l(hero.vus)..'^'.._l('gui.honors')..': '.._l(hero.honors)..'^^'
			end	
	return t
end


file_screen = room {
	nam = function(s) return _l('gui.persfile') end,
	_mission_list = '',--список пройденных миссий
	entered = function(s)
		inv_clear()
		take_my_stat( s._mission_list )
	end;
	dsc = function (s) 
			local t
			t = ''
			t = t..imgl(foto_get())
			t=t..file_info()
			
			t=t.._l('gui.failcnt')..': '..battle_count..'^'
			t=t.._l('gui.lossescnt')..': '..losses_count..'^'
			t=t.._l('gui.fragcnt')..': '..frag_count..'^'
			
			--t=t..'^^Выполненные задачи:^^'..s._mission_list
						
			return t
		end;
	
	
	
	obj = {  
	        obj{ nam='Назад', dsc= function(s) return '{'.._l('gui.back')..'}' end,act = function(s) back() end }
	       }
}

fail_screen = room {
	nam = function(s) return _l('gui.fail') end,
	pic=function(s) return 'img/'..prefs.thm..'/'..'file.png' end,
	entered = function(s)
		set_ui(UIT_QUEST)
	end,
	way = {file_screen},
	dsc = function(s)
			local t
			t=''
			t=t.._l('gui.fail2')..'^^'
			t=t..units_stat()
			return t 		
		end,

	obj = {
			obj{nam = 'Рестарт', dsc= function(s) return '{'.._l('gui.next')..'}' end ,act = 
					function(s) 
						misson_reset();
						mission_advance(); 
					end
				}	
		}
}

function statistic_calculate()
	local battle_sum, losses_sum, frag_sum, hm_sum, i,v = 0,0,0,0
	
	for i,v in ipairs(prefs.stat) do
		battle_sum =  battle_sum + v.battle_count
		losses_sum = losses_sum + v.losses_count
		frag_sum = frag_sum + v.frag_count
		hm_sum = hm_sum + v.hm_count
	end
	
	return {battle_sum,losses_sum,frag_sum,hm_sum}

end


function statistic_str()
			local t,r
			
			t=''
			r=statistic_calculate()
			
			t=t.._l('gui.failcnt')..': '..r[1]..'^'
			t=t.._l('gui.lossescnt')..': '..r[2]..'^'
			t=t.._l('gui.fragcnt')..': '..r[3]..'^'
			t=t.._l('gui.hmcnt')..': '..r[4]..'^^'			

			t=t..txtb(_l('gui.total')..': ').._l('mdns.resst'..gameres) 			

						
			return t
end

--очистка перед началом следующей миссии
function mission_clear()
	units_clear()
	swarm_kill_all()
end


function statistic_save()
				prefs.stat[mis_i] = { ['battle_count'] = battle_count+1, ['losses_count'] = losses_count, ['frag_count']=frag_count, ['hm_count']=hm_count } 
				prefs.completed[mis_i] = true 
				prefs:store();	
								
				battle_count = 0
				losses_count = 0
				frag_count = 0
				hm_count = 0

end

win_screen = room {
	nam = function(s) return _l('gui.win') end, 
	pic=function(s) return 'img/'..prefs.thm..'/'..'file.png' end,
	way = {file_screen},
	entered = function(s)
	set_ui(UIT_QUEST)
		
	end,
	dsc = function(s)
		local t,i,j
		t=''
		t=t..'^'.._l('gui.win2')..'^^'
		t=t..units_stat()
		return t
	end;
	obj = {
			obj{nam = 'Продолжить', dsc= function(s) return '{'.._l('gui.next')..'}' end,act = 
			function(s) 
				stop_all_noise()
				mission_clear()
				
				statistic_save()
				
				
				set_ui(UIT_MENU)
				walk(ep1menu)
				
				--mis_i = mis_i + 1;
				--mission_advance(); 
			end
				}	
		}

}

win_screen_ep2 = room {
	nam = function(s) return _l('gui.wine2') end, 
	entered = function(s)
		set_ui(UIT_QUEST)
	end,
	dsc = function(s)
		local t,i,j
		t=''
		t=t..'^'.._l('gui.wine22')..'^^'
		t=t..units_stat()
		return t
	end;
	obj = {
			obj{nam = 'Продолжить', dsc= function(s) return '{'.._l('gui.next')..'}' end,act = 
			function(s) 
				stop_all_noise()
				mission_clear()
				reset_game()
				set_ui(UIT_MENU)
				walk(main)
			end
				}	
		}

}

fail_screen_ep2 = room {
	nam = function(s) return _l('gui.faile2') end,
	entered = function(s)
		set_ui(UIT_QUEST)
	end,
	dsc = function(s)
			local t
			t=''
			t=t.._l('gui.failep22')..'^^'
			t=t..units_stat()
			return t 		
		end,

	obj = {
			obj{nam = 'Продолжить', dsc= function(s) return '{'.._l('gui.next')..'}' end ,act = 
					function(s) 
						stop_all_noise()
						mission_clear()
						reset_game()
						set_ui(UIT_MENU)
						walk(main)
					end
				}	
		}
}


function misson_reset()
	assert(mis[mis_i]~=nil)
	assert(mis[mis_i].isMission)
	assert(mis[mis_i].restart ~=nil)
	mis[mis_i]._step = mis[mis_i].restart-1;
end

-- выбор следующей локации в текущей миссии 
function mission_advance()
	assert(mis[mis_i]~=nil)
	assert(mis[mis_i].isMission or mis[mis_i].isUMission)
	assert( size(mis[mis_i].scenario) ~= 0)
	
	
	
	inv_clear()
	
	mis[mis_i]._step = mis[mis_i]._step + 1
	local nxt
	

	if size(mis[mis_i].scenario[mis[mis_i]._step] )>0 then --шаг сценария не пуст
		
		nxt = mis[mis_i].scenario[mis[mis_i]._step][ rnd(size(mis[mis_i].scenario[mis[mis_i]._step] ))  ]
		assert(nxt ~= nil)
		
		local i
		for i=0,10 do stop_sound(i) end
			
		if nxt.isQuest then
			set_ui(UIT_QUEST)
			walk(nxt)
		elseif nxt.isLoc then
			set_ui(UIT_LOC)	
			loc_install(nxt);
			walk(nxt)
		else
		error('6123509784509213')
		end
		
	else	--шаг сценария пуст, добрались до конца		
		mis[mis_i]._step = 0
		stop_all_noise()
		set_sound('track/Instantperson_-_Here_is_The_News.ogg',1)
		if mis[mis_i].isMission then 
			file_screen._mission_list = file_screen._mission_list..'* '..mis[mis_i].nam()..'^'
			walk(win_screen) 
		else 
			walk(win_screen_ep2) 
		end				
	end
	return true
 end




mission = function(s) 
	s.isMission = true
	s._step = 0
	
	return obj(s)
end


-- экран информации об отдельной миссии
umis_screen = room {
	nam = function(s) return mis[mis_i].nam()  end,
	entered = function(s)
		inv_clear()
	end;
	dsc = function (s) 
			local t
			t = ''
			t = t..imgl(hero.foto)
			
			
			t=t..file_info()..'^^'
			
			--t = t.._l('gui.name')..': '.._l(hero.fio)..'^'.._l('gui.age')..': '..hero.age..'^'.._l('gui.grade')..': '..grade_list[hero.grade]()..'^'.._l('gui.army')..': '.._l(hero.army)..'^'.._l('gui.vus')..': '.._l(hero.vus)..'^'.._l('gui.honors')..': '.._l(hero.honors)..'^^'
			
			t=t..mis[mis_i].text()..'^'

			return t
		end;
	
	obj = {  
	        obj{ nam='Начать', dsc= function(s) return '{'.._l('start')..'}^' end,act = function(s) mission_advance();   end }, -- walk(mis[mis_i].startway)
	        obj{ nam='В главное меню', dsc= function(s) return '{'.._l('gui.tomenu')..'}' end, act = function(s) stead.restart() end }

			}
}


-- запуск пользовательской миссии
function install_umission(umis)
	assert(umis~=nil)
	assert(umis.isUMission)

	mis = { umis }
	mis_i = 1
	if umis.install ~= nil then umis.install() end
     
	walk(umis_screen) 
end





-- отдельная миссия
umission = function(s)
	s.isUMission = true

	s._step = 0
	
	return obj(s)
end




